//=============================================================================
// SAL_ClearCacheOnTransfer.js
//=============================================================================

/*:
 * @plugindesc Clears the cache when the Transfer Player Event is called
 * @author SaliaNifo
 *
 * @param Clear Cache Enable Switch Id
 * @desc Switch id used to enable cache clearing
 * @default 10
 *
 */


var SaliaNifo = SaliaNifo || {};
SaliaNifo.Parameters = PluginManager.parameters('SAL_ClearCacheOnTransfer');
SaliaNifo.Param = SaliaNifo.Param || {};

SaliaNifo.Param.ClearCacheEnable = Number(SaliaNifo.Parameters['Clear Cache Enable Switch Id']);

Scene_Map.prototype.start = function() {
    Scene_Base.prototype.start.call(this);
    SceneManager.clearStack();
    if (this._transfer) {

        if(SaliaNifo.Param.ClearCacheEnable > 0 && $gameSwitches.value(SaliaNifo.Param.ClearCacheEnable)) {
            ImageManager.clear();
            ImageManager.loadFace("Akira-1");
            ImageManager.loadFace("Doken");
            ImageManager.loadFace("Echo-1");
            ImageManager.loadFace("Kachie");
            ImageManager.loadFace("Kari");
            ImageManager.loadFace("Miki");
            ImageManager.loadFace("Niki");
            ImageManager.loadFace("Tadase");
            ImageManager.loadFace("Tara");
            ImageManager.loadFace("Whyp");
            ImageManager.loadFace("Zephyr");
            ImageManager.loadSystem('IconSet');
            ImageManager.loadSystem('Damage');
            ImageManager.loadFace("Ferrik");
            ImageManager.loadCharacter("Akira-combined");
            ImageManager.loadCharacter("Akira-combined-2");
            ImageManager.loadCharacter("Akira-combined-Wind");
            ImageManager.loadCharacter("Akira-combined-X");
            ImageManager.loadCharacter("Akira-combinedxShiny");
            ImageManager.loadCharacter("Akira-combined-Xtra");
            ImageManager.loadCharacter("Akira-combined-Xtra-Wind");
            ImageManager.loadCharacter("Akira-fightpose");
            ImageManager.loadCharacter("Akira-Fightpose-Xtra");
            ImageManager.loadCharacter("Doken-Combined");
            ImageManager.loadCharacter("Doken-Combined-Xtra");
            ImageManager.loadCharacter("Doken-Combined-Xtra-Wind");
            ImageManager.loadCharacter("Doken-Fightpose");
            ImageManager.loadCharacter("Doken-Fightpose-Xtra");
            ImageManager.loadCharacter("Echo-Combined");
            ImageManager.loadCharacter("Echo-Combined-Wind");
            ImageManager.loadCharacter("Echo-Combined-Xtra");
            ImageManager.loadCharacter("Echo-Combined-Xtra-Wind");
            ImageManager.loadCharacter("Echo-Fightpose");
            ImageManager.loadCharacter("Echo-Fightpose-Xtra");
            ImageManager.loadCharacter("Ferrik-Combined");
            ImageManager.loadCharacter("Ferrik-Combined-Xtra");
            ImageManager.loadCharacter("Ferrik-Fightpose");
            ImageManager.loadCharacter("Ferrik-Fightpose-Xtra");
            ImageManager.loadCharacter("Ferrik-Wind");
            ImageManager.loadCharacter("Ferrik-Wind-Extra");
            ImageManager.loadCharacter("Kachie Combined");
            ImageManager.loadCharacter("Kachie Combined-2");
            ImageManager.loadCharacter("Kachie Combined-Wind");
            ImageManager.loadCharacter("Kachie Combined-Xtra");
            ImageManager.loadCharacter("Kachie Combined-Xtra-Wind");
            ImageManager.loadCharacter("Kachie-Fightpose");
            ImageManager.loadCharacter("Kachie-Fightpose-Xtra");
            ImageManager.loadCharacter("Kari-combined");
            ImageManager.loadCharacter("Kari-combined-Wind");
            ImageManager.loadCharacter("Kari-combined-Xtra");
            ImageManager.loadCharacter("Kari-combined-Xtra-fightpose");
            ImageManager.loadCharacter("Kari-combined-Xtra-Wind");
            ImageManager.loadCharacter("Kari-fightpose");
            ImageManager.loadCharacter("Miki-combined");
            ImageManager.loadCharacter("Miki-combined-wind");
            ImageManager.loadCharacter("Miki-combined-Xtra");
            ImageManager.loadCharacter("Miki-combined-Xtra-Wind");
            ImageManager.loadCharacter("Miki-fightpose");
            ImageManager.loadCharacter("Miki-Fightpose-Xtra");
            ImageManager.loadCharacter("Niki-combined");
            ImageManager.loadCharacter("Niki-combined-wind");
            ImageManager.loadCharacter("Niki-combined-Xtra");
            ImageManager.loadCharacter("Niki-combined-Xtra-Wind");
            ImageManager.loadCharacter("Niki-fightpose");
            ImageManager.loadCharacter("Niki-Fightpose-Xtra");
            ImageManager.loadCharacter("Sadie-Combined");
            ImageManager.loadCharacter("Sadie-Combined-Wind");
            ImageManager.loadCharacter("SkeepSpritesHeroes");
            ImageManager.loadCharacter("SkeepSpritesHeroes2");
            ImageManager.loadCharacter("SkeepSpritesHeroes3");
            ImageManager.loadCharacter("SkeepSpritesHeroes22");
            ImageManager.loadCharacter("SkeepSpritesHeroesShiny");
            ImageManager.loadCharacter("Tadase-Combined");
            ImageManager.loadCharacter("Tadase-Combined-Wind");
            ImageManager.loadCharacter("Tadase-Combined-Xtra");
            ImageManager.loadCharacter("Tadase-Combined-Xtra-Wind");
            ImageManager.loadCharacter("Tadase-Fightpose");
            ImageManager.loadCharacter("Tadase-Fightpose-Xtra");
            ImageManager.loadCharacter("Tara Combined");
            ImageManager.loadCharacter("Tara Combined-Wind");
            ImageManager.loadCharacter("Tara Combined-Wind-Xtra");
            ImageManager.loadCharacter("Tara Combined-Xtra");
            ImageManager.loadCharacter("Tara-Fightpose");
            ImageManager.loadCharacter("Tara-Fightpose-Xtra");
            ImageManager.loadCharacter("Whyp-Combined");
            ImageManager.loadCharacter("Whyp-Combined-Wind");
            ImageManager.loadCharacter("Whyp-Combined-Xtra");
            ImageManager.loadCharacter("Whyp-Combined-Xtra-Fightpose");
            ImageManager.loadCharacter("Whyp-Combined-Xtra-Wind");
            ImageManager.loadCharacter("Whyp-Fightpose");
            ImageManager.loadCharacter("XAkiraGlomp");
            ImageManager.loadCharacter("XAkiZephsleepy");
            ImageManager.loadCharacter("XKachieAkira");
            ImageManager.loadCharacter("Zephyr-Combined");
            ImageManager.loadCharacter("Zephyr-Combined-Wind");
            ImageManager.loadCharacter("Zephyr-Combined-Wind-Xtra");
            ImageManager.loadCharacter("Zephyr-Combined-Wind-Xtra2");
            ImageManager.loadCharacter("Zephyr-Combined-Xtra");
            ImageManager.loadCharacter("Zephyr-Combined-Xtra2");
            ImageManager.loadCharacter("Zephyr-Fightpose");
            ImageManager.loadCharacter("Zephyr-Fightpose-Xtra");
            ImageManager.loadCharacter("Zephyr-Fightpose-Xtra2");
        }
        this.fadeInForTransfer();
        this._mapNameWindow.open();
        $gameMap.autoplay();
    } else if (this.needsFadeIn()) {
        this.startFadeIn(this.fadeSpeed(), false);
    }
    this.menuCalling = false;
};

Game_Interpreter.prototype.command201 = function() {
    if (!$gameParty.inBattle() && !$gameMessage.isBusy()) {
        var mapId, x, y;
        if (this._params[0] === 0) {  // Direct designation
            mapId = this._params[1];
            x = this._params[2];
            y = this._params[3];
        } else {  // Designation with variables
            mapId = $gameVariables.value(this._params[1]);
            x = $gameVariables.value(this._params[2]);
            y = $gameVariables.value(this._params[3]);
        }
        $gamePlayer.reserveTransfer(mapId, x, y, this._params[4], this._params[5]);
        this.setWaitMode('transfer');
        this._index++;
    }
    return false;
};

