//=============================================================================
// SAL_WidthNullPatch.js
//=============================================================================

/*:
 * @plugindesc Sets Sprite._bitmap to a new Bitmap() if _bitmap is null in
 * _onBitmapLoad()
 * @author SaliaNifo
 *
 * @help This plugin does not provide plugin commands.
 *
 */

Sprite.prototype._onBitmapLoad = function() {
    if (this._frame.width === 0 && this._frame.height === 0) {
        if (this._bitmap === null) {
          this._bitmap = new Bitmap();
        }
        this._frame.width = this._bitmap.width;
        this._frame.height = this._bitmap.height;
    }
    this._refresh();
};
