//=============================================================================
// SAL_WindowFadeOpen.js
//=============================================================================

/*:
 * @plugindesc Change window open animation mode with a switch
 * @author SaliaNifo
 *
 * @help This plugin does not provide plugin commands.
 *
 * @param Window Fade Open
 * @desc  Switch ID to control whether windows fade, or change height
 * @default 26
 * 
 */


var SaliaNifo = SaliaNifo || {};
SaliaNifo.Parameters = PluginManager.parameters('SAL_WindowFadeOpen');
SaliaNifo.Param = SaliaNifo.Param || {};

SaliaNifo.Param.WindowFadeOpen = SaliaNifo.Parameters['Window Fade Open'];

Object.defineProperty(Window.prototype, 'openness', {
    get: function() {
        return this._openness;
    },
    set: function(value) {
        if (this._openness !== value) {
            this._openness = value.clamp(0, 255);
            if(!$gameSwitches.value(SaliaNifo.Param.WindowFadeOpen)) {
                this._windowSpriteContainer.scale.y = this._openness / 255;
                this._windowSpriteContainer.y = this.height / 2 * (1 - this._openness / 255);
            } else {
                this._windowSpriteContainer.scale.y = 1;
                this._windowSpriteContainer.y = 0;
                this._windowSpriteContainer.alpha = this._openness / 255;
            }
        }
    },
    configurable: true
});

